body {
    padding: 50px 150px;
}

.tooltip-container {
    margin-bottom: 100px;
}

.tooltip-container p {
    margin: 5px 0;
}

.btn-container {
    margin: 30px 0;
}

.input-block {
    display: inline-block;
}

.controls {
    margin: 10px 0;
}

.tooltip {
    position: relative;
}

/* Applies to all tooltips */
.tooltip::before,
.tooltip::after {
    text-transform: none; /* opinion 2 */
    font-size: .9em; /* opinion 3 */
    line-height: 1;
    user-select: none;
    pointer-events: none;
    position: absolute;
    display: none;
    opacity: 0;
}

.tooltip-content {
    display: none;
    position: absolute;
    font-family: Helvetica, sans-serif;
    text-align: center;
    min-width: 3em;
    max-width: 21em;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    padding: 1ch 1.5ch;
    border-radius: .3ch;
    box-shadow: 0 1em 2em -.5em rgba(0, 0, 0, 0.35);
    background: #333;
    color: #fff;
    z-index: 1000; /* absurdity 2 */
}

/* FLOW: UP */
.tooltip.tooltip-up .tooltip-content {
    bottom: 100%;
    border-bottom-width: 0;
    border-top-color: #333;
}

.tooltip.tooltip-up .tooltip-content {
    left: 50%;
    transform: translate(-50%, -.5em);
}

/* FLOW: DOWN */
.tooltip.tooltip-down .tooltip-content {
    top: 100%;
    border-top-width: 0;
    border-bottom-color: #333;
}

.tooltip.tooltip-down .tooltip-content {
    top: 100%;
}


.tooltip.tooltip-down .tooltip-content{
    left: 50%;
    transform: translate(-50%, .5em);
}

/* FLOW: LEFT */
.tooltip.tooltip-left .tooltip-content {
    top: 50%;
    right: calc(100% + 5px);
    transform: translate(-.5em, -50%);
}

/* FLOW: RIGHT */
.tooltip.tooltip-right .tooltip-content {
    top: 50%;
    border-left-width: 0;
    border-right-color: #333;
    left: calc(100% + 5px);
    transform: translate(.5em, -50%);
}
